"use strict";

{
  const C3 = self.C3;
  C3.Plugins.skymen_skinsCore.Cnds = {
    IsEmpty() {
      return (
        Object.keys(this.skins).length === 0 &&
        this.skins.constructor === Object
      );
    },
    HasSkin(skin) {
      return this.skins[skin] != undefined;
    },
    HasSubSkin(skin, subskin) {
      return (
        this.skins[skin] != undefined && this.skins[skin][subskin] != undefined
      );
    },
    OnSkin(skin) {
      return skin == this.lastSkin;
    },
    OnSubSkin(skin, subskin) {
      return skin == this.lastSkin && subskin == this.lastSubskin;
    },
    OnAnySkin() {
      return true;
    },
    OnAnySubSkin(skin) {
      return skin == this.lastSkin;
    },
    OnAnySubAnySkin() {
      return true;
    },
    ForEachSkin() {
      const runtime = this._runtime;
      const eventSheetManager = runtime.GetEventSheetManager();
      const currentEvent = runtime.GetCurrentEvent();
      const solModifiers = currentEvent.GetSolModifiers();
      const eventStack = runtime.GetEventStack();
      const oldFrame = eventStack.GetCurrentStackFrame();
      const newFrame = eventStack.Push(currentEvent);

      Object.keys(this.skins).forEach((k) => {
        // ... optionally update state here ...
        this.curSkin = k;
        // Push a copy of the current SOL
        eventSheetManager.PushCopySol(solModifiers);

        // Retrigger the current event, running a single loop iteration
        currentEvent.Retrigger(oldFrame, newFrame);

        // Pop the current SOL
        eventSheetManager.PopSol(solModifiers);
      });

      // Pop the event stack frame
      eventStack.Pop();

      // Return false since event already executed
      return false;
    },
    ForEachSubSkin(skin) {
      const runtime = this._runtime;
      const eventSheetManager = runtime.GetEventSheetManager();
      const currentEvent = runtime.GetCurrentEvent();
      const solModifiers = currentEvent.GetSolModifiers();
      const eventStack = runtime.GetEventStack();
      const oldFrame = eventStack.GetCurrentStackFrame();
      const newFrame = eventStack.Push(currentEvent);

      if (this.skins[skin] == undefined) return false;

      Object.keys(this.skins[skin]).forEach((k) => {
        // ... optionally update state here ...
        this.curSubSkin = k;
        // Push a copy of the current SOL
        eventSheetManager.PushCopySol(solModifiers);

        // Retrigger the current event, running a single loop iteration
        currentEvent.Retrigger(oldFrame, newFrame);

        // Pop the current SOL
        eventSheetManager.PopSol(solModifiers);
      });

      // Pop the event stack frame
      eventStack.Pop();

      // Return false since event already executed
      return false;
    },
  };
}
